///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 24.02.2016 Creation time: 09:03:20
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS NewForm FROM _NewForm
   EXPORTED:
      METHOD init
      METHOD create
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Execute method of the super class
   ::_NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Execute method of the super class
   ::_NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )


   * Display the form
   ::show()

RETURN self


******************************************************************************
* Main procedure to test a form
******************************************************************************
PROCEDURE Main

   LOCAL nEvent, oXbp, mp1, mp2, oDlg, nTest

   oDlg := NewForm():New():Create()

   ? "Test"

   nTest := 3

   do case
      case nTest = 1

           // SetAppWindow() ist das CRT Fenster, ich will Dialog steuern.
           // so wird das CRT Fenster bewegt.
           SetTimerEvent( 300, {|| qout( date(),time(),"Switch ", switch() ) } )

      case nTest = 2

           // So wird ein beliebiges Fenster gesteuert
           SetTimerEvent( 300, {|| qout( date(),time(),"Switch ", switch(oDlg) ) } )

      case nTest = 3

           // So wird ein beliebiges Fenster gesteuert
           SetTimerEvent( 300, {|| qout( date(),time(),"Switch ", AllwaysOnTop(oDlg) ) } )

   endcase

   // beide beziehen sich offensichtlich auf SetAppWindow()

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

*------------------------------------------
function switch(oDlg)
   static lOnTop := .f., cTxt
   if empty(oDlg)
      oDlg := setAppWindow()
   endif
   if lOnTop
      cTxt := "nach Hinten " + iif(oDlg:toBack(),"OK","Fehler")
   else
      cTxt := "nach Vorne  " + iif(oDlg:toFront(),"OK","Fehler")
   endif
   lOnTop := ! lOnTop
RETURN cTxt

*------------------------------------------
function AllwaysOnTop(oDlg)
   static lOnTop := .f., cTxt
   if empty(oDlg)
      oDlg := setAppWindow()
   endif
   if lOnTop
      cTxt := "nach Hinten "
      oDlg:alwaysOnTop := .f.
      oDlg:configure()
      oDlg:toBack()
   else
      cTxt := "On Top ! "
      oDlg:alwaysOnTop := .t.
      oDlg:configure()
      oDlg:toFront()
   endif
   lOnTop := ! lOnTop
RETURN cTxt



* Include program code for the implementation-level class of the form
* #include "_ANW_MAIN.PRG"

//EOF
/////